/*------------------------------------------------------- File Description -*\

  Copyright (C) Odin TeleSystems Inc., 2009

  DESCRIPTION

   Debug output for DSP SPMs.

\*--------------------------------------------------------------------------*/

#ifndef DBGOUT__H__DEFINED
#define DBGOUT__H__DEFINED

#define DPRINTF_USE_PTR_TAG

#if defined (_TMS320DM64X) || defined (__linux__) || defined(xdc_target_name__)
  #define DAVINCI_PLATFORM 1
#else 
  #undef DAVINCI_PLATFORM
#endif

#include "../Dsp/DspFwk/Inc/io_fwk.h"

#ifndef DEBUG_PRINTFS 
  static inline void dprintf(char * FormatStr, ...){}
#else
  
  #ifndef DAVINCI_PLATFORM
    short dprintf(char * FormatStr, ...);
  #else
    #include "Dsp64Api.h"
  #endif
#endif

#if defined(DEBUG_PRINTFS) && defined(PRINT_SHOWERROR)
  #define ShowError() dprintf("FAILED: file '%s' , line: %d", __FILE__,__LINE__)
#else
  #define ShowError()
#endif


#ifdef DEBUG_MALLOC

  #include <stdlib.h>

//  void* MyMalloc(size_t e);
//  void MyFree(void *e,char *ee,int ew);

//  #define malloc(x) MyMalloc(x)
//  #define free(x) MyFree(x, __FILE__,__LINE__)

  extern unsigned short g_nAlloc;
  #define malloc(sz) malloc(sz); g_nAlloc += sz; dprintf("Malloc (%d) at %s:%d | Used: %d",(sz),__FILE__,__LINE__, g_nAlloc)
//  #define malloc(sz) malloc(sz); dprintf("Malloc (%d) at %s:%d",(sz),__FILE__,__LINE__)

#endif

extern FWK_OTX_HANDLE hDbgHandle;

#endif


/*--------------------------------------------------------------------------*\

  Copyright (C) Odin TeleSystems Inc., 2009


  All rights reserved. No part of this computer program may be reproduced,
  stored in any retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording, or otherwise,
  without the prior written permission of Odin TeleSystems Inc., or without
  a permission stipulated in the agreement/contract under which this computer
  program was supplied.

\*--------------------------------------------------------------------------*/

